#!/usr/bin/perl 


#┌─────────────────────────────────
#│ テキストファイル表示ソフト v1.00 (2022/11/06)
#| update 2023/11/14
#│ Copyright (c) Dotmatrix
#│ info@cgishop.net
#│ https://cgishop.net/
#└─────────────────────────────────
$version = 'テキストファイル表示ソフト v1.00';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このスクリプトは、フリーソフトです。このスクリプトを使用した
#│    いかなる損害に対して作者は、一切の責任を負いません。
#│ 2. 直接メールによる質問は、お受けいたしておりません。
#│    
#│ 3. 送信フォームのHTMLページの作成に関しては、創作自由です。
#│    スクリプトは、よく勉強してから改造してください。
#│ 4. 良いご意見が有ればHPで受け付けます。
#│    前向きに検討し、今後の参考とさせていただきます。
#└─────────────────────────────────

#
#  [ 設置例 ]
#
#  desktop / fileview.pl (実行権限）[755]
#                  
#

#-------------------------------------------------
#  ▼基本設定
#-------------------------------------------------

use Tk;
use utf8;
use Tk::TextUndo;
use Encode qw(decode);
# $Bin はスクリプトのディレクトリ名
use FindBin qw($Bin);
#@INC に追加します
use lib "$Bin";


#--------------------------------------main window-------------------------------------------
$top = MainWindow->new;
#メインウィンドウのタイトル
$top->title("テキストファイル表示ソフト");
$top->optionAdd( '*font' => 'ＭＳゴシック 10');


#--------------------------------------.txtファイルのみ抽出--------------------------------------


chdir("$Bin");
 @file    = glob "*.txt";
foreach(@file){
next if /^\.{1,2}$/;    # '.'や'..'をスキップ
push @aaa,$_;
}


#----------------------------------スクロールバー付きリストボックス方向にoをつけると自動になるosoeow
$lis = $top->Scrolled('Listbox',
		    -background=> 'white',
		    -scrollbars=> 'osoe',
                    -height => 20,
                    -selectforeground=> 'brown',
                    -selectbackground=> 'cyan',
                    -selectmode=> 'single')
  ->pack(-side=>'left',-fill=>'both',-expand => 'yes');
  
 

 #-----------------------テキストファイルのファイル名をリストボックスに入れる 


foreach $str (@aaa) {

  chomp($str);
  $str2 = decode('utf8',"$str");
  $lis->insert('end',$str2);
  
}

#----------セレクトの初期選択---------------

 $i = $lis->selectionSet(1);
       
#--------------------------------------------select＆copy　ボタン------------------------------------------------
#----------フレームセット---------------

$f1 = $top->Frame()->pack(-anchor=>"w");


#--------------------------------------------ボタン--------------------------------------------------------------

$f1->Button(-fg => 'blue',-font => ['','10','bold'],-text=> "select＆copy",-command=> \&select_copy)->pack(-side=>'left',-anchor=>'w');

$f1->Button(-text=> "copy",-command=> \&copy)->pack(-side=>'left',-anchor=>'w');

$f1->Button(-text=> "終了",-command=> \&onExit)->pack(-side=>'left',-anchor=>'e');


#---------------------------------------------関数---------------------------------------------------------------

#コピー
sub copy {
    $txt = $utext -> get('1.0' , 'end');
    $top->clipboardClear; 
    $top->clipboardAppend('--', $txt ); 
    
};
# 終了
sub onExit {
    exit;  
};


#--------------------------------------------テキスト表示------------------------------------------------------
 

$utext = $top -> Scrolled('TextUndo',
			-background =>'white',
			-width      => 80,
			-height     => 25,
			-wrap       => 'word',
			-scrollbars => 'se');
$utext -> pack( -side   => 'bottom',
		-fill   => 'both',
		-expand =>'yes');


#--------------------------------------------メイン処理関数------------------------------------------------------

#選択してコピーとラベルの表示


  sub select_copy{
  
   $utext -> delete('1.0' , 'end');
   $i = $lis->curselection;
  
   $as = $lis->get($i);
   
   $file = "$Bin"."/"."$as";



  open (IN,$file);
  
  @aaa = <IN>;
  
  close (IN);       
  
  @aaa1 = reverse @aaa;
  
  foreach $gettxt1(@aaa1){

    $gettxt = decode('utf8',"$gettxt1");

    $utext -> insert('1.0' , $gettxt);
    }
    $gettxt = $utext -> get('1.0' , 'end');
 
 $top->clipboardClear; 
 $top->clipboardAppend('--', $gettxt ); 


}


MainLoop;



#---
# fileview.pl
